<template>
  <div class="full-width">
    <div
      class="flex items-center"
      v-if="isLoadingConfig"
    >
      <div
        class="flex items-center"
      >
        <q-spinner name="mat" size="32px"/>
        <span class="q-ml-sm">Loading collection config...</span>
      </div>
    </div>
    <div class="q-mt-sm" v-if="config && !isLoadingConfig">
      <q-btn
        color="blue"
        size="md"
        :label="isSavingRecord ? 'Saving...' : 'Save collection'"
        @click="save"
        class="q-mb-md"
        :disable="isSavingRecord"
      />
    </div>
    <div class="q-mt-sm" v-if="config">
      <main-collection-info
        :config="config"
      />
      <draggable
        class="q-list q-py-none q-mt-md q-list-separator"
        :list="config.methods"
        handle=".q-item-icon"
      >
        <q-collapsible
          group="method"
          v-for="(method, index) in config.methods"
          :key="index"
          icon="drag_handle"
          :label="method.name ? `<b>${method.name}</b> (${method.type})` : `<i class='text-grey'>no name</i>`"
        >
          <div class="flex items-center full-width">
            <q-input
              v-model="method.name"
              inverted-light
              color="white"
              stack-label="Name"
            />
            <q-input
              v-model="method.description"
              inverted-light
              color="white"
              stack-label="Description"
              class="q-ml-sm col-grow"
            />
            <q-btn
              color="blue"
              icon="build"
              class="q-ml-sm"
              round
              @click="editingMethodIndex = index"
            />
            <q-btn
              color="red"
              icon="delete"
              class="q-ml-sm"
              round
              @click="config.methods.splice(index, 1)"
            />
          </div>
        </q-collapsible>
      </draggable>
      <div class="q-mt-md flex justify-end">
        <q-btn
          label="Add list"
          icon="add"
          color="primary"
          @click="addMethod('list')"
        />
        <q-btn
          label="Add action"
          icon="add"
          color="primary"
          class="q-ml-sm"
          @click="addMethod('action')"
        />
        <method-editor
          :method="config.methods[editingMethodIndex]"
          @close="editingMethodIndex = null"
        />
      </div>
    </div>
  </div>
</template>

<script>
    import Columns from './column/columns';
    import endpointsMixin from '../../../../../mixins/endpointsMixin';
    import MainCollectionInfo from './mainInfo';
    import {
      collectionActionTypeConfig,
      collectionListTypeConfig,
      collectionMethod,
    } from '../../../../../utilities/defaults/collection';
    import MethodEditor from './methodEditor';

    export default {
      components: { MethodEditor, MainCollectionInfo, Columns },
      mixins: [endpointsMixin],
      props: {
        id: String,
      },
      data() {
        return {
          config: null,

          editingMethodIndex: null,

          isLoadingConfig: false,
          isSavingRecord: false,
        };
      },
      methods: {
        addMethod(type) {
          this.config.methods.push({
            ...collectionMethod,
            type,
            config: {
              ...({
                list: collectionListTypeConfig,
                action: collectionActionTypeConfig,
              }[type]),
            },
          });
        },
        save() {
          this.isSavingRecord = true;

          const {
            migratedVersion,
          } = this.config;

          const record = {
            collection_id: this.id,
          };

          if (migratedVersion === 1) {
            this.fetchCollection(this.id, false)
              .then((res) => {
                record.collection_config = JSON.stringify({
                  ...res,
                  __migratedConfig: this.config,
                });
                this.saveCollection(record)
                  .then(() => {
                    this.isSavingRecord = false;
                  })
                  .catch(() => {
                    this.isSavingRecord = false;
                  });
              });
          } else {
            record.collection_config = JSON.stringify(this.config);
            this.saveCollection(record)
              .then(() => {
                this.isSavingRecord = false;
              })
              .catch(() => {
                this.isSavingRecord = false;
              });
          }
        },
        fetchConfig() {
          return new Promise((resolve, reject) => {
            this.isLoadingConfig = true;

            this.fetchCollection(this.id)
              .then((config) => {
                this.config = config;
                this.isLoadingConfig = false;
                resolve();
              })
              .catch(() => {
                this.isLoadingConfig = true;
                reject();
              });
          });
        },
      },
      watch: {
        id() {
          this.config = null;
          this.$nextTick(() => {
            this.fetchConfig();
          });
        },
      },
    };
</script>
